Bug 1328968 - Review Request: capnproto - A data interchange format and capability-based RPC system
Summary: Review Request: capnproto - A data interchange format and capability-based RP...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Andy Lutomirski
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
: 1040243 (view as bug list)
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2016-04-20 18:31 UTC by Neal Gompa
Modified: 2016-05-15 02:40 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2016-05-07 11:46:29 UTC
luto: fedora-review+


Attachments (Terms of Use)

Description Neal Gompa 2016-04-20 18:31:29 UTC
Spec URL: http://kinginuyasha.enanocms.org/downloads/capnproto.spec
SRPM URL: http://kinginuyasha.enanocms.org/downloads/capnproto-0.5.3-1.fc23.src.rpm

Description:
Cap’n Proto is an insanely fast data interchange format
and capability-based RPC system. Think JSON, except binary.
Or think Protocol Buffers, except faster. In fact, in benchmarks,
Cap’n Proto is INFINITY TIMES faster than Protocol Buffers.


Fedora Account System Username: ngompa

Comment 1 Neal Gompa 2016-04-20 18:32:19 UTC
This supersedes bug#1040243.

Comment 2 Andy Lutomirski 2016-04-21 17:10:54 UTC
*** Bug 1040243 has been marked as a duplicate of this bug. ***

Comment 3 Andy Lutomirski 2016-04-21 17:45:00 UTC
This looks generally sensible.

Before I go run fedora-review on it and check all the boxes, why did you choose to name it capnproto instead of capnproto-c++?

Also, shouldn't README.txt be packaged, or was that removed upstream?

Comment 4 Neal Gompa 2016-04-22 01:15:06 UTC
@Andy:

I chose to name it capnproto for consistency with other distros that have it packaged, namely Debian[0] and Ubuntu[1], and the upstream project itself is named as such, even though the tarball is still capnproto-c++.

The README.txt file is in the tarball, but it merely provides instructions on how to build it from source, which is generally not useful for a pre-built package, so I elected to not include it.

[0]: https://packages.debian.org/sid/capnproto
[1]: http://packages.ubuntu.com/xenial/capnproto

Comment 5 Neal Gompa 2016-04-26 15:22:29 UTC
To be consistent with Debian packaging of capnproto, I've swapped things around so that the tools are the main package and libraries are in a subpackage.

Since a review hasn't started, I've just gone ahead and replaced the SPEC and SRPM.

Spec URL: http://kinginuyasha.enanocms.org/downloads/capnproto.spec
SRPM URL: http://kinginuyasha.enanocms.org/downloads/capnproto-0.5.3-1.fc23.src.rpm

Comment 6 Andy Lutomirski 2016-04-27 02:04:11 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed

One biggish issue: this installs unversioned .so files.  More precisely, it installs nonstandard versioned .so files.  They look like:

SONAME               libcapnp-0.5.3.so

This may be against the guidelines.  It may also be fine.  You could try
to convince me that it's fine, or you could ask FPC.

Also, see:

https://github.com/sandstorm-io/capnproto/issues/318


Issues:
=======
- Package installs properly.
  Note: Installation errors (see attachment)
  See: https://fedoraproject.org/wiki/Packaging:Guidelines
- All build dependencies are listed in BuildRequires, except for any that
  are listed in the exceptions section of Packaging Guidelines.
  Note: These BR are not needed: gcc-c++
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#Exceptions_2


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.

I think this is https://bugzilla.redhat.com/show_bug.cgi?id=1330804, but
I'm not quite sure that this refers to.

[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "MIT/X11 (BSD like)", "BSD (3 clause)", "GPL (v2 or later)",
     "Unknown or generated". 36 files have unknown license. Detailed output
     of licensecheck in
     /home/luto/devel/fedora/cnp/capnproto/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[x]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 0 bytes in 0 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     capnproto-libs , capnproto-devel , capnproto-debuginfo

This is fine: the autogenerated requires/provides will do the trick.

[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Scriptlets must be sane, if used.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[ ]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Rpmlint is run on all installed packages.
     Note: Mock build failed
     See: http://fedoraproject.org/wiki/Packaging/Guidelines#rpmlint

I think fedora-review is just confused.

[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.


Installation errors
-------------------
INFO: mock.py version 1.2.17 starting (python version = 3.4.3)...
Start: init plugins
INFO: selinux enabled
Finish: init plugins
Start: run
Start: chroot init
INFO: calling preinit hooks
INFO: enabled root cache
INFO: enabled dnf cache
Start: cleaning dnf metadata
Finish: cleaning dnf metadata
Mock Version: 1.2.17
INFO: Mock Version: 1.2.17
Finish: chroot init
INFO: installing package(s): /home/luto/devel/fedora/cnp/capnproto/results/capnproto-0.5.3-1.fc25.x86_64.rpm /home/luto/devel/fedora/cnp/capnproto/results/capnproto-libs-0.5.3-1.fc25.x86_64.rpm /home/luto/devel/fedora/cnp/capnproto/results/capnproto-devel-0.5.3-1.fc25.x86_64.rpm /home/luto/devel/fedora/cnp/capnproto/results/capnproto-debuginfo-0.5.3-1.fc25.x86_64.rpm /home/luto/devel/fedora/cnp/capnproto/results/capnproto-debuginfo-0.5.3-1.fc25.x86_64.rpm
ERROR: Command failed. See logs for output.
 # /usr/bin/dnf --installroot /var/lib/mock/fedora-rawhide-x86_64/root/ --releasever 25 --disableplugin=local --setopt=deltarpm=false install /home/luto/devel/fedora/cnp/capnproto/results/capnproto-0.5.3-1.fc25.x86_64.rpm /home/luto/devel/fedora/cnp/capnproto/results/capnproto-libs-0.5.3-1.fc25.x86_64.rpm /home/luto/devel/fedora/cnp/capnproto/results/capnproto-devel-0.5.3-1.fc25.x86_64.rpm /home/luto/devel/fedora/cnp/capnproto/results/capnproto-debuginfo-0.5.3-1.fc25.x86_64.rpm /home/luto/devel/fedora/cnp/capnproto/results/capnproto-debuginfo-0.5.3-1.fc25.x86_64.rpm --setopt=tsflags=nocontexts


Rpmlint
-------
Checking: capnproto-0.5.3-1.fc25.x86_64.rpm
          capnproto-libs-0.5.3-1.fc25.x86_64.rpm
          capnproto-devel-0.5.3-1.fc25.x86_64.rpm
          capnproto-debuginfo-0.5.3-1.fc25.x86_64.rpm
          capnproto-0.5.3-1.fc25.src.rpm
capnproto.x86_64: W: no-documentation
capnproto.x86_64: W: no-manual-page-for-binary capnpc-c++
capnproto.x86_64: W: no-manual-page-for-binary capnp
capnproto.x86_64: W: no-manual-page-for-binary capnpc-capnp
capnproto.x86_64: W: no-manual-page-for-binary capnpc
capnproto-libs.x86_64: W: shared-lib-calls-exit /usr/lib64/libkj-0.5.3.so _exit@GLIBC_2.2.5
capnproto-libs.x86_64: W: no-documentation
capnproto-devel.x86_64: W: only-non-binary-in-usr-lib

I filed https://bugzilla.redhat.com/show_bug.cgi?id=1330804 for this.

capnproto-devel.x86_64: W: no-documentation
capnproto-debuginfo.x86_64: W: spurious-executable-perm /usr/src/debug/capnproto-c++-0.5.3/src/kj/miniposix.h
5 packages and 0 specfiles checked; 0 errors, 10 warnings.




Requires
--------
capnproto (rpmlib, GLIBC filtered):
    capnproto-libs(x86-64)
    libc.so.6()(64bit)
    libcapnp-0.5.3.so()(64bit)
    libcapnpc-0.5.3.so()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libkj-0.5.3.so()(64bit)
    libm.so.6()(64bit)
    libpthread.so.0()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    libstdc++.so.6(CXXABI_1.3.9)(64bit)
    rtld(GNU_HASH)

capnproto-devel (rpmlib, GLIBC filtered):
    /usr/bin/pkg-config
    capnproto-libs(x86-64)
    pkgconfig(capnp)

capnproto-libs (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    ld-linux-x86-64.so.2()(64bit)
    libc.so.6()(64bit)
    libcapnp-0.5.3.so()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libkj-0.5.3.so()(64bit)
    libkj-async-0.5.3.so()(64bit)
    libm.so.6()(64bit)
    libpthread.so.0()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    libstdc++.so.6(CXXABI_1.3.9)(64bit)
    rtld(GNU_HASH)

capnproto-debuginfo (rpmlib, GLIBC filtered):



Provides
--------
capnproto:
    capnproto
    capnproto(x86-64)

capnproto-devel:
    capnproto-devel
    capnproto-devel(x86-64)
    pkgconfig(capnp)
    pkgconfig(capnp-rpc)

capnproto-libs:
    capnproto-libs
    capnproto-libs(x86-64)
    libcapnp-0.5.3.so()(64bit)
    libcapnp-rpc-0.5.3.so()(64bit)
    libcapnpc-0.5.3.so()(64bit)
    libkj-0.5.3.so()(64bit)
    libkj-async-0.5.3.so()(64bit)

capnproto-debuginfo:
    capnproto-debuginfo
    capnproto-debuginfo(x86-64)



Unversioned so-files
--------------------
capnproto-libs: /usr/lib64/libcapnp-0.5.3.so
capnproto-libs: /usr/lib64/libcapnp-rpc-0.5.3.so
capnproto-libs: /usr/lib64/libcapnpc-0.5.3.so
capnproto-libs: /usr/lib64/libkj-0.5.3.so
capnproto-libs: /usr/lib64/libkj-async-0.5.3.so

Source checksums
----------------
https://capnproto.org/capnproto-c++-0.5.3.tar.gz :
  CHECKSUM(SHA256) this package     : cdb17c792493bdcd4a24bcd196eb09f70ee64c83a3eccb0bc6534ff560536afb
  CHECKSUM(SHA256) upstream package : cdb17c792493bdcd4a24bcd196eb09f70ee64c83a3eccb0bc6534ff560536afb


Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -r -n /home/luto/rpmbuild/SRPMS/capnproto-0.5.3-1.fc23.src.rpm
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 7 Neal Gompa 2016-04-27 02:52:16 UTC
So the version scheme is not unknown to Fedora. The scheme is commonly used by applications that try to enforce a consistent filename structure across platforms. The style of versioned library is the same used on Windows and Mac OS X. It's typically used in order to avoid libtool (which handles reformatting the structure of the library name depending on the platform), as some people seem to dislike it.

In Fedora, we have two important packages that actually use this format in their libraries: libdb (Berkeley DB) and llvm-libs (LLVM).

The key is that both unversioned and versioned variants of the library name exist (which they do), and that the unversioned one is in the devel subpackage (which it is). RPM's dependency generators handle this case pretty well, so I wouldn't be overly concerned about it.

Comment 8 Andy Lutomirski 2016-04-27 04:00:50 UTC
Fair enough.  No complaints from me, then.  The version system will clearly work in the sense that capnproto-libs updates will change the soname and rpm will notice.

Comment 9 Gwyn Ciesla 2016-04-28 12:38:55 UTC
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/capnproto

Comment 10 Fedora Update System 2016-04-28 17:30:30 UTC
capnproto-0.5.3-2.el7 has been submitted as an update to Fedora EPEL 7. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2016-78c0114b50

Comment 11 Fedora Update System 2016-04-28 17:31:17 UTC
capnproto-0.5.3-2.fc22 has been submitted as an update to Fedora 22. https://bodhi.fedoraproject.org/updates/FEDORA-2016-4d440c2df0

Comment 12 Fedora Update System 2016-04-28 17:31:51 UTC
capnproto-0.5.3-2.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2016-e8d746cca5

Comment 13 Fedora Update System 2016-04-28 17:32:32 UTC
capnproto-0.5.3-2.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2016-c023e41c9b

Comment 14 Fedora Update System 2016-04-29 17:22:16 UTC
capnproto-0.5.3-2.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-c023e41c9b

Comment 15 Fedora Update System 2016-04-30 02:23:12 UTC
capnproto-0.5.3-2.fc22 has been pushed to the Fedora 22 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-4d440c2df0

Comment 16 Fedora Update System 2016-04-30 02:23:51 UTC
capnproto-0.5.3-2.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-e8d746cca5

Comment 17 Fedora Update System 2016-04-30 04:23:50 UTC
capnproto-0.5.3-2.el7 has been pushed to the Fedora EPEL 7 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2016-78c0114b50

Comment 18 Fedora Update System 2016-05-07 11:46:27 UTC
capnproto-0.5.3-2.fc24 has been pushed to the Fedora 24 stable repository. If problems still persist, please make note of it in this bug report.

Comment 19 Fedora Update System 2016-05-08 15:20:50 UTC
capnproto-0.5.3-2.fc22 has been pushed to the Fedora 22 stable repository. If problems still persist, please make note of it in this bug report.

Comment 20 Fedora Update System 2016-05-08 20:53:49 UTC
capnproto-0.5.3-2.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.

Comment 21 Fedora Update System 2016-05-15 02:40:30 UTC
capnproto-0.5.3-2.el7 has been pushed to the Fedora EPEL 7 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.